package com.minerarcana.floralchemy.block;

import java.io.IOException;
import java.io.InputStream;
import java.util.*;

import javax.annotation.Nullable;

import com.minerarcana.floralchemy.item.ItemBlockTinted;
import com.teamacronymcoders.base.blocks.IHasBlockColor;
import com.teamacronymcoders.base.blocks.IHasItemBlock;
import com.teamacronymcoders.base.client.ClientHelper;
import com.teamacronymcoders.base.util.ColourHelper;

import net.minecraft.block.Block;
import net.minecraft.block.BlockBush;
import net.minecraft.block.material.Material;
import net.minecraft.block.properties.*;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.client.Minecraft;
import net.minecraft.client.resources.IResource;
import net.minecraft.client.util.ITooltipFlag;
import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.*;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import net.minecraftforge.fml.common.registry.ForgeRegistries;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

public class BlockCrystalthorn extends BlockBush implements IHasBlockColor, IHasItemBlock {

    public static final int maxAge = 7;
    public static final PropertyInteger AGE = PropertyInteger.func_177719_a("age", 0, maxAge);
    public static final PropertyBool BERRIES = PropertyBool.func_177716_a("berries");
    private static final AxisAlignedBB[] AABB = new AxisAlignedBB[] { new AxisAlignedBB(0.3, 0, 0.3, 0.7, 0.4, 0.7),
            new AxisAlignedBB(0.2, 0, 0.2, 0.8, 0.5, 0.8), new AxisAlignedBB(0.2, 0, 0.2, 0.8, 0.6, 0.8),
            new AxisAlignedBB(0.2, 0, 0.2, 0.8, 0.6, 0.8), new AxisAlignedBB(0.1, 0, 0.1, 0.9, 0.6, 0.9),
            new AxisAlignedBB(0.1, 0, 0.1, 0.9, 0.6, 0.9), new AxisAlignedBB(0, 0, 0, 1, 1, 1),
            new AxisAlignedBB(0, 0, 0, 1, 1, 1) };
    private Tuple<ResourceLocation, Integer> crystal;
    private ItemBlock itemBlock;
    private ItemStack cachedCrystalStack = ItemStack.field_190927_a;
    private Optional<Integer> cachedColor = Optional.empty();

    public BlockCrystalthorn(Tuple<ResourceLocation, Integer> entry) {
        super(Material.field_151585_k);
        func_180632_j(field_176227_L.func_177621_b().func_177226_a(AGE, 0).func_177226_a(BERRIES, false));
        func_149663_c("crystalthorn");
        func_149675_a(true);
        crystal = entry;
    }

    @Override
    @SideOnly(Side.CLIENT)
    public void func_190948_a(ItemStack stack, @Nullable World worldIn, List<String> tooltip, ITooltipFlag flagIn) {
        super.func_190948_a(stack, worldIn, tooltip, flagIn);
        tooltip.add(getCrystalStack().func_82833_r());
    }

    @Override
    public boolean func_180639_a(World worldIn, BlockPos pos, IBlockState state, EntityPlayer playerIn,
            EnumHand hand, EnumFacing facing, float hitX, float hitY, float hitZ) {
        if(state.func_177229_b(AGE) == maxAge && state.func_177229_b(BERRIES)) {
            ItemStack stack = getCrystalStack();
            if(!stack.func_190926_b()) {
                if(playerIn.func_191521_c(stack)) {
                    playerIn.func_70097_a(DamageSource.field_76367_g, 3F);
                    worldIn.func_175656_a(pos, state.func_177226_a(BERRIES, false));
                }
            }
        }
        return false;
    }

    @Override
    public void func_180645_a(World worldIn, BlockPos pos, IBlockState state, Random random) {
        if(random.nextBoolean()) {
            if(state.func_177229_b(AGE) < maxAge) {
                worldIn.func_175656_a(pos, state.func_177226_a(AGE, state.func_177229_b(AGE) + 1));
                return;
            }
            if(!state.func_177229_b(BERRIES) && random.nextInt(10) == 0) {
                worldIn.func_175656_a(pos, state.func_177226_a(BERRIES, true));
            }
        }
    }

    @Override
    public IBlockState func_176203_a(int meta) {
        if(meta == maxAge + 1) {
            return func_176223_P().func_177226_a(BERRIES, true).func_177226_a(AGE, maxAge);
        }
        return func_176223_P().func_177226_a(AGE, meta);
    }

    @Override
    public int func_176201_c(IBlockState state) {
        return state.func_177229_b(BERRIES) ? state.func_177229_b(AGE) : state.func_177229_b(AGE) + 1;
    }

    @Override
    public AxisAlignedBB func_185496_a(IBlockState state, IBlockAccess source, BlockPos pos) {
        return AABB[state.func_177229_b(AGE)];
    }

    @Override
    protected BlockStateContainer func_180661_e() {
        return new BlockStateContainer(this, new IProperty[] { AGE, BERRIES });
    }

    @Override
    public void func_180657_a(World worldIn, EntityPlayer player, BlockPos pos, IBlockState state,
            @Nullable TileEntity te, ItemStack stack) {
        player.func_70097_a(DamageSource.field_76367_g, 3F);
        super.func_180657_a(worldIn, player, pos, state, te, stack);
    }

    @Override
    public void func_180634_a(World worldIn, BlockPos pos, IBlockState state, Entity entityIn) {
        entityIn.func_70097_a(DamageSource.field_76367_g, 1F);
    }

    @SideOnly(Side.CLIENT)
    @Override
    public int colorMultiplier(IBlockState state, IBlockAccess world, BlockPos pos, int tintIndex) {
        if(cachedColor.isPresent()) {
            return cachedColor.get();
        }
        else {
            ItemStack cStack = getCrystalStack();
            int tintColor = Minecraft.func_71410_x().getItemColors().func_186728_a(cStack, 0);
            if(tintColor == -1) {
                // TODO This is very failure prone, need a better way.
                IResource resource = ClientHelper.getResource(new ResourceLocation(crystal.func_76341_a().func_110624_b(),
                        "textures/items/" + crystal.func_76341_a().func_110623_a() + ".png"));
                if(resource != null) {
                    InputStream stream = resource.func_110527_b();
                    tintColor = ColourHelper.getColour(stream);
                    try {
                        stream.close();
                    }
                    catch(IOException e) {
                        e.printStackTrace();
                    }
                }
            }
            cachedColor = Optional.of(tintColor);
            return tintColor;
        }
    }

    @Override
    public Block getBlock() {
        return this;
    }

    @Override
    public ItemBlock getItemBlock() {
        return itemBlock == null ? new ItemBlockTinted<BlockCrystalthorn>(this) : itemBlock;
    }

    public ItemStack getCrystalStack() {
        if(cachedCrystalStack.func_190926_b()) {
            cachedCrystalStack = new ItemStack(ForgeRegistries.ITEMS.getValue(crystal.func_76341_a()), 1,
                    crystal.func_76340_b());
        }
        return cachedCrystalStack;
    }
}
