package com.minerarcana.floralchemy.block;

import java.util.*;

import com.minerarcana.floralchemy.item.ItemBlockLeakyCauldron;
import com.minerarcana.floralchemy.tileentity.TileEntityLeakyCauldron;
import com.teamacronymcoders.base.blocks.BlockTEBase;

import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.*;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import net.minecraftforge.fluids.FluidStack;
import net.minecraftforge.fluids.FluidUtil;
import net.minecraftforge.fluids.capability.CapabilityFluidHandler;
import net.minecraftforge.fluids.capability.IFluidHandler;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

public class BlockLeakyCauldron extends BlockTEBase<TileEntityLeakyCauldron> {

    public BlockLeakyCauldron() {
        super(Material.field_151573_f, "leaky_cauldron");
        this.func_149675_a(true);
        this.setItemBlock(new ItemBlockLeakyCauldron(this));
    }
    
    @Override
    public void func_180650_b(World worldIn, BlockPos pos, IBlockState state, Random rand) {
        if(!worldIn.field_72995_K) {
            BlockPos down = pos.func_177977_b();
            getTileEntity(worldIn, pos).ifPresent(tile -> {
                if(tile.tank.getFluidAmount() > 0) {
                    //Leak to world
                    if(tile.tank.getFluidAmount() == 1000 && tile.tank.getFluid().getFluid().getBlock() != null && worldIn.func_175623_d(down)) {
                        worldIn.func_175656_a(down, tile.tank.getFluid().getFluid().getBlock().func_176223_P());
                    }
                    //Leak to fluid handlers
                    else if(worldIn.func_175625_s(down) != null && worldIn.func_175625_s(down).hasCapability(CapabilityFluidHandler.FLUID_HANDLER_CAPABILITY, EnumFacing.UP)) {
                        IBlockState old = worldIn.func_180495_p(down);
                            IFluidHandler otherTank = worldIn.func_175625_s(down)
                                    .getCapability(CapabilityFluidHandler.FLUID_HANDLER_CAPABILITY, EnumFacing.UP);
                            FluidStack test = FluidUtil.tryFluidTransfer(otherTank, tile.tank, 500, false);
                            if(test != null && test.amount == 500) {
                                FluidUtil.tryFluidTransfer(otherTank, tile.tank, 100, true);
                                worldIn.markAndNotifyBlock(down, worldIn.func_175726_f(down), old,
                                        worldIn.func_180495_p(down), 3);
                                worldIn.func_175625_s(down).func_70296_d();
                                tile.func_70296_d();
                            }
                    }
                }
            });
        }
    }
    
    //TODO Move this handling to a central static method
    @Override
    public boolean func_180639_a(World worldIn, BlockPos pos, IBlockState state, EntityPlayer playerIn,
            EnumHand hand, EnumFacing facing, float hitX, float hitY, float hitZ) {
        if(playerIn.func_184586_b(hand).hasCapability(CapabilityFluidHandler.FLUID_HANDLER_ITEM_CAPABILITY, null)) {
            Optional<TileEntityLeakyCauldron> te = getTileEntity(worldIn, pos);
            if(te.isPresent()) {
                if(FluidUtil.interactWithFluidHandler(playerIn, hand, worldIn, pos, facing)) {
                    te.get().sendBlockUpdate();
                    return true;
                }
            }
        }
        return super.func_180639_a(worldIn, pos, state, playerIn, hand, facing, hitX, hitY, hitZ);
    }

    @Override
    public Class<TileEntityLeakyCauldron> getTileEntityClass() {
        return TileEntityLeakyCauldron.class;
    }

    @Override
    public TileEntity createTileEntity(World world, IBlockState blockState) {
        return new TileEntityLeakyCauldron();
    }
    
    @Override
    public boolean func_149662_c(IBlockState state) {
        return false;
    }

    @Override
    @SideOnly(Side.CLIENT)
    public BlockRenderLayer func_180664_k() {
        return BlockRenderLayer.CUTOUT;
    }

    @Override
    @SideOnly(Side.CLIENT)
    public boolean func_176225_a(IBlockState blockState, IBlockAccess blockAccess, BlockPos pos,
            EnumFacing side) {
        return true;
    }

}
